class BaseLevelData
{
   var aPanels;
   var aPanelBg2;
   var nRequiredMS;
   var nCollectedMS;
   var nMiniStones;
   var nTimeTaken;
   var bCompleted;
   var bLocked;
   var nLevelType;
   var nLevelNumber;
   var sLevelName;
   var nTimeAllowed;
   static var SECONDS = 1000;
   static var MINUTES = 60 * BaseLevelData.SECONDS;
   static var STATUS_COMPLETED = 1;
   static var STATUS_INCOMPLETE = 2;
   static var LEVEL_TYPE_STORY = 1;
   static var LEVEL_TYPE_USER = 2;
   static var POINTS_BASE = 50000;
   static var POINTS_PER_MS_BASE = 750;
   static var POINTS_PER_MS_OVER = 1500;
   static var POINTS_PER_MINISTONES = 100;
   static var POINTS_PER_MILLISECOND_REMAINING = 1.25;
   function BaseLevelData()
   {
      this.aPanels = new Array();
      this.aPanelBg2 = new Array();
      this.nRequiredMS = 0;
      this.nCollectedMS = 0;
      this.nMiniStones = 0;
      this.nTimeTaken = 0;
      this.bCompleted = false;
      this.bLocked = true;
   }
   function onInit()
   {
      var _loc2_ = SharedObject.getLocal(PlayerStatus.SAVE_SO_NAME);
      if(_loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber] != undefined)
      {
         this.bCompleted = _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].bCompleted;
         this.bLocked = _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].bLocked;
         this.nCollectedMS = _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nCollectedMS;
         this.nMiniStones = _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nMiniStones;
         this.nTimeTaken = _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nTimeTaken;
      }
      false;
   }
   function doSave()
   {
      var _loc2_ = SharedObject.getLocal(PlayerStatus.SAVE_SO_NAME);
      _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber] = new Object();
      _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].bCompleted = this.bCompleted;
      _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].bLocked = this.bLocked;
      _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nCollectedMS = this.nCollectedMS;
      _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nMiniStones = this.nMiniStones;
      _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nTimeTaken = this.nTimeTaken;
      if(this.nLevelType == BaseLevelData.LEVEL_TYPE_USER)
      {
         _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nLevelNumber = this.nLevelNumber;
         _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].sLevelName = this.sLevelName;
         _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nTimeAllowed = this.nTimeAllowed;
         _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].nRequiredMS = this.nRequiredMS;
         _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber].aPanels = this.aPanels;
      }
      _loc2_.flush();
      false;
   }
   function doDeleteFromSave()
   {
      var _loc2_ = SharedObject.getLocal(PlayerStatus.SAVE_SO_NAME);
      delete _loc2_.data["LevelType" + this.nLevelType + "_LevelNumber" + this.nLevelNumber];
      _loc2_.flush();
      false;
   }
   function set LevelNumber(__nLevelNumber)
   {
      this.nLevelNumber = __nLevelNumber;
   }
   function get LevelNumber()
   {
      return this.nLevelNumber;
   }
   function set LevelName(__sLevelName)
   {
      this.sLevelName = __sLevelName;
   }
   function get LevelName()
   {
      var _loc2_ = this.sLevelName;
      if(_loc2_ == undefined || _loc2_ == "")
      {
         _loc2_ = "Game " + this.LevelNumber;
      }
      return _loc2_;
   }
   function get Locked()
   {
      return this.bLocked;
   }
   function set Locked(__bLocked)
   {
      this.bLocked = __bLocked;
   }
   function get Completed()
   {
      return this.bCompleted;
   }
   function set Completed(__bCompleted)
   {
      this.bCompleted = __bCompleted;
   }
   function set LevelType(__nLevelType)
   {
      this.nLevelType = __nLevelType;
   }
   function get LevelType()
   {
      return this.nLevelType;
   }
   function get Panels()
   {
      return this.aPanels;
   }
   function set RequiredMS(__nRequiredMS)
   {
      this.nRequiredMS = __nRequiredMS;
   }
   function get RequiredMS()
   {
      return this.nRequiredMS;
   }
   function set CollectedMS(__nCollectedMS)
   {
      this.nCollectedMS = __nCollectedMS;
   }
   function get CollectedMS()
   {
      return this.nCollectedMS;
   }
   function set TimeAllowed(__nTimeAllowed)
   {
      this.nTimeAllowed = __nTimeAllowed;
   }
   function get TimeAllowed()
   {
      return this.nTimeAllowed;
   }
   function set TimeTaken(__nTimeTaken)
   {
      this.nTimeTaken = __nTimeTaken;
   }
   function get TimeTaken()
   {
      return this.nTimeTaken;
   }
   function set MiniStones(__nMiniStones)
   {
      this.nMiniStones = __nMiniStones;
   }
   function get MiniStones()
   {
      return this.nMiniStones;
   }
   function get Score()
   {
      return this.getScore();
   }
   function getScore()
   {
      var _loc2_ = 0;
      if(this.Completed)
      {
         _loc2_ += BaseLevelData.POINTS_BASE;
         _loc2_ += Math.min(this.CollectedMS,this.RequiredMS) * BaseLevelData.POINTS_PER_MS_BASE;
         _loc2_ += Math.max(this.CollectedMS - this.RequiredMS,0) * BaseLevelData.POINTS_PER_MS_OVER;
         _loc2_ += Math.floor((this.TimeAllowed - this.TimeTaken) * BaseLevelData.POINTS_PER_MILLISECOND_REMAINING);
         _loc2_ += this.MiniStones * BaseLevelData.POINTS_PER_MINISTONES;
      }
      return _loc2_;
   }
}
