class LevelSelector
{
   var mcRef;
   var nLevelType;
   static var STORY_ROW_NUM = 4;
   function LevelSelector(__mcRef, __nLevelType)
   {
      this.mcRef = __mcRef;
      this.nLevelType = __nLevelType;
      if(this.nLevelType == BaseLevelData.LEVEL_TYPE_USER)
      {
         this.doGenerateUserGrid();
      }
      else
      {
         this.doGenerateStoryGrid();
      }
   }
   function doCreateLevel(__nRowNum)
   {
      Game.Instance.doCreateNewLevel(__nRowNum);
   }
   function doDeleteLevel(__oLevel)
   {
      Game.Instance.doAskDeleteLevel(__oLevel);
   }
   function onLevelDeleted()
   {
      this.doGenerateUserGrid();
   }
   function doEditLevel(__oLevel)
   {
      Game.Instance.doEditLevel(__oLevel);
   }
   function doPlayLevel(__oLevel)
   {
      Game.Instance.doStartLevel(__oLevel,this.nLevelType);
   }
   function doDestroy()
   {
   }
   function doGenerateUserGrid()
   {
      var _loc2_ = 1;
      while(_loc2_ <= PlayerStatus.MAX_USER_LEVELS)
      {
         var _loc3_ = Game.Instance.Status.getLevelData(this.nLevelType,_loc2_);
         if(_loc3_ != undefined)
         {
            this.mcRef["mcLevel" + _loc2_].gotoAndStop("Active");
            this.mcRef["mcLevel" + _loc2_]._visible = true;
            this.mcRef["mcLevel" + _loc2_].txtLevel.text = _loc3_.LevelNumber;
            this.mcRef["mcLevel" + _loc2_].btnLevel.onRelease = Library.Utils.Delegate.create(this,this.doPlayLevel,_loc3_);
            this.mcRef["mcLevel" + _loc2_].txtLevelName.text = _loc3_.LevelName;
            this.mcRef["mcLevel" + _loc2_].btnDelete.onRelease = Library.Utils.Delegate.create(this,this.doDeleteLevel,_loc3_);
            this.mcRef["mcLevel" + _loc2_].btnEdit.onRelease = Library.Utils.Delegate.create(this,this.doEditLevel,_loc3_);
            this.mcRef["mcLevel" + _loc2_].txtScore.text = Library.Utils.Tools.getFormatedNumber(_loc3_.Score,6);
         }
         else
         {
            this.mcRef["mcLevel" + _loc2_].gotoAndStop("Empty");
            this.mcRef["mcLevel" + _loc2_].btnCreate.onRelease = Library.Utils.Delegate.create(this,this.doCreateLevel,_loc2_);
         }
         _loc2_ = _loc2_ + 1;
      }
   }
   function doGenerateStoryGrid()
   {
      var _loc4_ = 0;
      var _loc2_ = undefined;
      _loc2_ = 1;
      while(_loc2_ <= Game.Instance.Status.getLevelQuantity(this.nLevelType))
      {
         var _loc3_ = Game.Instance.Status.getLevelData(this.nLevelType,_loc2_);
         if(_loc3_.Locked)
         {
            this.mcRef["mcLevel" + _loc2_].gotoAndStop("Locked");
            this.mcRef["btnLevel" + _loc2_].enabled = false;
         }
         else
         {
            this.mcRef["mcLevel" + _loc2_].gotoAndStop("Active");
            this.mcRef["btnLevel" + _loc2_].onRelease = Library.Utils.Delegate.create(this,this.doPlayLevel,_loc3_);
            this.mcRef["mcLevel" + _loc2_].txtScore.text = Library.Utils.Tools.getFormatedNumber(_loc3_.Score,6);
         }
         _loc4_ += _loc3_.Score;
         _loc2_ = _loc2_ + 1;
      }
      while(_loc2_ <= LevelSelector.STORY_ROW_NUM)
      {
         this.mcRef["mcLevel" + _loc2_].gotoAndStop("Locked");
         this.mcRef["btnLevel" + _loc2_].enabled = false;
         _loc2_ = _loc2_ + 1;
      }
      this.mcRef.mcScore.txtTotalScore.text = Library.Utils.Tools.getFormatedNumber(_loc4_,8);
   }
}
